/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUTP_TIPOPAGTO                                              */
/* Tabela : TIPOPAGTO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*  Adalberto Tedoro Oliveira                                                 */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOPAGTO
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOPAGTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPPG := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOPAGTO,0) <> NVL(:NEW.CDTIPOPAGTO,0)) OR
         (NVL(:OLD.NMTIPOPAGTO,0) <> NVL(:NEW.NMTIPOPAGTO,0)) OR 
         (NVL(:OLD.IDTIPOPAGTO,0) <> NVL(:NEW.IDTIPOPAGTO,0)) THEN
         :NEW.DTULTATUTPPG := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOPAGTO', '', 'CDTIPOPAGTO='||:OLD.CDTIPOPAGTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOPAGTO MODIFY DTULTATUTPPG DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOPAGTO','4.11.078'); END;
/

